diff --git a/libpurple/tests/test_contact.c b/libpurple/tests/test_contact_info.c
copy from libpurple/tests/test_contact.c
copy to libpurple/tests/test_contact_info.c
--- a/libpurple/tests/test_contact.c
+++ b/libpurple/tests/test_contact_info.c
@@ -26,26 +26,20 @@
  * Tests
  *****************************************************************************/
 static void
-test_purple_contact_new(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_new(void) {
+	PurpleContactInfo *info = NULL;
 
-	account = purple_account_new("test", "test");
-	contact = purple_contact_new(account, "id");
+	info = purple_contact_info_new("id");
 
-	g_assert_true(purple_contact_get_account(contact) == account);
-	g_assert_cmpstr(purple_contact_get_id(contact), ==, "id");
+	g_assert_cmpstr(purple_contact_info_get_id(info), ==, "id");
 
-	g_clear_object(&contact);
-	g_clear_object(&account);
+	g_clear_object(&info);
 }
 
 static void
-test_purple_contact_properties(void) {
-	PurpleAccount *account = NULL;
-	PurpleAccount *account1 = NULL;
-	PurpleContact *contact = NULL;
-	PurpleContactPermission permission;
+test_purple_contact_info_properties(void) {
+	PurpleContactInfo *info = NULL;
+	PurpleContactInfoPermission permission;
 	PurplePerson *person = NULL;
 	PurplePerson *person1 = NULL;
 	PurplePresence *presence1 = NULL;
@@ -57,7 +51,6 @@
 	gchar *display_name = NULL;
 	gchar *alias = NULL;
 
-	account = purple_account_new("test", "test");
 	avatar = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8, 1, 1);
 	person = purple_person_new();
 
@@ -65,22 +58,20 @@
 	 * call the setter methods, so by doing it this way we exercise more of the
 	 * code.
 	 */
-	contact = g_object_new(
-		PURPLE_TYPE_CONTACT,
-		"account", account,
+	info = g_object_new(
+		PURPLE_TYPE_CONTACT_INFO,
 		"id", "id1",
 		"username", "username",
 		"display-name", "display-name",
 		"alias", "alias",
 		"avatar", avatar,
 		"person", person,
-		"permission", PURPLE_CONTACT_PERMISSION_ALLOW,
+		"permission", PURPLE_CONTACT_INFO_PERMISSION_ALLOW,
 		NULL);
 
 	/* Now use g_object_get to read all of the properties. */
-	g_object_get(contact,
+	g_object_get(info,
 		"id", &id,
-		"account", &account1,
 		"username", &username,
 		"display-name", &display_name,
 		"alias", &alias,
@@ -93,7 +84,6 @@
 
 	/* Compare all the things. */
 	g_assert_cmpstr(id, ==, "id1");
-	g_assert_true(account1 == account);
 	g_assert_cmpstr(username, ==, "username");
 	g_assert_cmpstr(display_name, ==, "display-name");
 	g_assert_cmpstr(alias, ==, "alias");
@@ -101,11 +91,10 @@
 	g_assert_nonnull(presence1);
 	g_assert_nonnull(tags);
 	g_assert_true(person1 == person);
-	g_assert_true(permission == PURPLE_CONTACT_PERMISSION_ALLOW);
+	g_assert_true(permission == PURPLE_CONTACT_INFO_PERMISSION_ALLOW);
 
 	/* Free/unref all the things. */
 	g_clear_pointer(&id, g_free);
-	g_clear_object(&account1);
 	g_clear_pointer(&username, g_free);
 	g_clear_pointer(&display_name, g_free);
 	g_clear_pointer(&alias, g_free);
@@ -116,230 +105,195 @@
 	g_clear_object(&person1);
 
 	g_clear_object(&avatar);
-	g_clear_object(&contact);
-	g_clear_object(&account);
+	g_clear_object(&info);
 }
 
 /******************************************************************************
  * get_name_for_display tests
  *****************************************************************************/
 static void
-test_purple_contact_get_name_for_display_person_with_alias(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_get_name_for_display_person_with_alias(void) {
+	PurpleContactInfo *info = NULL;
 	PurplePerson *person = NULL;
 	const char *alias = NULL;
 
-	account = purple_account_new("test", "test");
-
 	person = purple_person_new();
 	purple_person_set_alias(person, "this is the alias");
 
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_person(contact, person);
+	info = purple_contact_info_new(NULL);
+	purple_contact_info_set_person(info, person);
 
-	alias = purple_contact_get_name_for_display(contact);
+	alias = purple_contact_info_get_name_for_display(info);
 	g_assert_cmpstr(alias, ==, "this is the alias");
 
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 	g_clear_object(&person);
 }
 
 static void
-test_purple_contact_get_name_for_display_contact_with_alias(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_get_name_for_display_contact_info_with_alias(void) {
+	PurpleContactInfo *info = NULL;
 	PurplePerson *person = NULL;
 	const char *alias = NULL;
 
-	account = purple_account_new("test", "test");
 	person = purple_person_new();
 
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_person(contact, person);
+	info = purple_contact_info_new(NULL);
+	purple_contact_info_set_person(info, person);
 
-	purple_contact_set_alias(contact, "this is the alias");
+	purple_contact_info_set_alias(info, "this is the alias");
 
-	alias = purple_contact_get_name_for_display(contact);
+	alias = purple_contact_info_get_name_for_display(info);
 	g_assert_cmpstr(alias, ==, "this is the alias");
 
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 	g_clear_object(&person);
 }
 
 static void
-test_purple_contact_get_name_for_display_contact_with_display_name(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_get_name_for_display_contact_info_with_display_name(void) {
+	PurpleContactInfo *info = NULL;
 	PurplePerson *person = NULL;
 	const char *alias = NULL;
 
-	account = purple_account_new("test", "test");
 	person = purple_person_new();
 
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_person(contact, person);
+	info = purple_contact_info_new(NULL);
+	purple_contact_info_set_person(info, person);
 
-	purple_contact_set_display_name(contact, "this is the display name");
+	purple_contact_info_set_display_name(info, "this is the display name");
 
-	alias = purple_contact_get_name_for_display(contact);
+	alias = purple_contact_info_get_name_for_display(info);
 	g_assert_cmpstr(alias, ==, "this is the display name");
 
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 	g_clear_object(&person);
 }
 
 static void
-test_purple_contact_get_name_for_display_username_fallback(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_get_name_for_display_username_fallback(void) {
+	PurpleContactInfo *info = NULL;
 	PurplePerson *person = NULL;
 	const char *alias = NULL;
 
-	account = purple_account_new("test", "test");
 	person = purple_person_new();
 
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact, "username");
-	purple_contact_set_person(contact, person);
+	info = purple_contact_info_new(NULL);
+	purple_contact_info_set_username(info, "username");
+	purple_contact_info_set_person(info, person);
 
-	alias = purple_contact_get_name_for_display(contact);
+	alias = purple_contact_info_get_name_for_display(info);
 	g_assert_cmpstr(alias, ==, "username");
 
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 	g_clear_object(&person);
 }
 
 static void
-test_purple_contact_get_name_for_display_id_fallback(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_get_name_for_display_id_fallback(void) {
+	PurpleContactInfo *info = NULL;
 	PurplePerson *person = NULL;
 	const char *alias = NULL;
 
-	account = purple_account_new("test", "test");
 	person = purple_person_new();
 
-	contact = purple_contact_new(account, "id");
-	purple_contact_set_person(contact, person);
+	info = purple_contact_info_new("id");
+	purple_contact_info_set_person(info, person);
 
-	alias = purple_contact_get_name_for_display(contact);
+	alias = purple_contact_info_get_name_for_display(info);
 	g_assert_cmpstr(alias, ==, "id");
 
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 	g_clear_object(&person);
 }
 
 /******************************************************************************
- * purple_contact_compare tests
+ * purple_contact_info_compare tests
  *****************************************************************************/
 static void
-test_purple_contact_compare_not_null__null(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_compare_not_null__null(void) {
+	PurpleContactInfo *info = NULL;
 
-	account = purple_account_new("test", "test");
-	contact = purple_contact_new(account, NULL);
+	info = purple_contact_info_new(NULL);
 
-	g_assert_cmpint(purple_contact_compare(contact, NULL), <, 0);
+	g_assert_cmpint(purple_contact_info_compare(info, NULL), <, 0);
 
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 }
 
 static void
-test_purple_contact_compare_null__not_null(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+test_purple_contact_info_compare_null__not_null(void) {
+	PurpleContactInfo *info = NULL;
 
-	account = purple_account_new("test", "test");
-	contact = purple_contact_new(account, NULL);
+	info = purple_contact_info_new(NULL);
 
-	g_assert_cmpint(purple_contact_compare(NULL, contact), >, 0);
+	g_assert_cmpint(purple_contact_info_compare(NULL, info), >, 0);
 
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 }
 
 static void
-test_purple_contact_compare_null__null(void) {
-	g_assert_cmpint(purple_contact_compare(NULL, NULL), ==, 0);
+test_purple_contact_info_compare_null__null(void) {
+	g_assert_cmpint(purple_contact_info_compare(NULL, NULL), ==, 0);
 }
 
 static void
-test_purple_contact_compare_person__no_person(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact_a = NULL;
-	PurpleContact *contact_b = NULL;
+test_purple_contact_info_compare_person__no_person(void) {
+	PurpleContactInfo *info_a = NULL;
+	PurpleContactInfo *info_b = NULL;
 	PurplePerson *person = NULL;
 
-	account = purple_account_new("test", "test");
-
-	contact_a = purple_contact_new(account, NULL);
+	info_a = purple_contact_info_new(NULL);
 	person = purple_person_new();
-	purple_contact_set_person(contact_a, person);
+	purple_contact_info_set_person(info_a, person);
 
-	contact_b = purple_contact_new(account, NULL);
-
-	g_assert_cmpint(purple_contact_compare(contact_a, contact_b), <, 0);
+	info_b = purple_contact_info_new(NULL);
 
-	g_clear_object(&account);
-	g_clear_object(&contact_a);
-	g_clear_object(&contact_b);
+	g_assert_cmpint(purple_contact_info_compare(info_a, info_b), <, 0);
+
+	g_clear_object(&info_a);
+	g_clear_object(&info_b);
 	g_clear_object(&person);
 }
 
 static void
-test_purple_contact_compare_no_person__person(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact_a = NULL;
-	PurpleContact *contact_b = NULL;
+test_purple_contact_info_compare_no_person__person(void) {
+	PurpleContactInfo *info_a = NULL;
+	PurpleContactInfo *info_b = NULL;
 	PurplePerson *person = NULL;
 
-	account = purple_account_new("test", "test");
+	info_a = purple_contact_info_new(NULL);
 
-	contact_a = purple_contact_new(account, NULL);
-
-	contact_b = purple_contact_new(account, NULL);
+	info_b = purple_contact_info_new(NULL);
 	person = purple_person_new();
-	purple_contact_set_person(contact_b, person);
-
-	g_assert_cmpint(purple_contact_compare(contact_a, contact_b), >, 0);
+	purple_contact_info_set_person(info_b, person);
 
-	g_clear_object(&account);
-	g_clear_object(&contact_a);
-	g_clear_object(&contact_b);
+	g_assert_cmpint(purple_contact_info_compare(info_a, info_b), >, 0);
+
+	g_clear_object(&info_a);
+	g_clear_object(&info_b);
 	g_clear_object(&person);
 }
 
 static void
-test_purple_contact_compare_name__name(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact_a = NULL;
-	PurpleContact *contact_b = NULL;
+test_purple_contact_info_compare_name__name(void) {
+	PurpleContactInfo *info_a = NULL;
+	PurpleContactInfo *info_b = NULL;
 
-	account = purple_account_new("test", "test");
-
-	contact_a = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact_a, "aaa");
+	info_a = purple_contact_info_new(NULL);
+	purple_contact_info_set_username(info_a, "aaa");
 
-	contact_b = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact_b, "zzz");
+	info_b = purple_contact_info_new(NULL);
+	purple_contact_info_set_username(info_b, "zzz");
 
-	g_assert_cmpint(purple_contact_compare(contact_a, contact_b), <, 0);
-	g_assert_cmpint(purple_contact_compare(contact_b, contact_a), >, 0);
+	g_assert_cmpint(purple_contact_info_compare(info_a, info_b), <, 0);
+	g_assert_cmpint(purple_contact_info_compare(info_b, info_a), >, 0);
 
-	purple_contact_set_username(contact_b, "aaa");
-	g_assert_cmpint(purple_contact_compare(contact_b, contact_a), ==, 0);
+	purple_contact_info_set_username(info_b, "aaa");
+	g_assert_cmpint(purple_contact_info_compare(info_b, info_a), ==, 0);
 
-	g_clear_object(&account);
-	g_clear_object(&contact_a);
-	g_clear_object(&contact_b);
+	g_clear_object(&info_a);
+	g_clear_object(&info_b);
 }
 
 /******************************************************************************
@@ -351,34 +305,34 @@
 
 	test_ui_purple_init();
 
-	g_test_add_func("/contact/new",
-	                test_purple_contact_new);
-	g_test_add_func("/contact/properties",
-	                test_purple_contact_properties);
+	g_test_add_func("/contact-info/new",
+	                test_purple_contact_info_new);
+	g_test_add_func("/contact-info/properties",
+	                test_purple_contact_info_properties);
 
-	g_test_add_func("/contact/get_name_for_display/person_with_alias",
-	                test_purple_contact_get_name_for_display_person_with_alias);
-	g_test_add_func("/contact/get_name_for_display/contact_with_alias",
-	                test_purple_contact_get_name_for_display_contact_with_alias);
-	g_test_add_func("/contact/get_name_for_display/contact_with_display_name",
-	                test_purple_contact_get_name_for_display_contact_with_display_name);
-	g_test_add_func("/contact/get_name_for_display/username_fallback",
-	                test_purple_contact_get_name_for_display_username_fallback);
-	g_test_add_func("/contact/get_name_for_display/id_fallback",
-	                test_purple_contact_get_name_for_display_id_fallback);
+	g_test_add_func("/contact-info/get_name_for_display/person_with_alias",
+	                test_purple_contact_info_get_name_for_display_person_with_alias);
+	g_test_add_func("/contact-info/get_name_for_display/contact_with_alias",
+	                test_purple_contact_info_get_name_for_display_contact_info_with_alias);
+	g_test_add_func("/contact-info/get_name_for_display/contact_with_display_name",
+	                test_purple_contact_info_get_name_for_display_contact_info_with_display_name);
+	g_test_add_func("/contact-info/get_name_for_display/username_fallback",
+	                test_purple_contact_info_get_name_for_display_username_fallback);
+	g_test_add_func("/contact-info/get_name_for_display/id_fallback",
+	                test_purple_contact_info_get_name_for_display_id_fallback);
 
-	g_test_add_func("/contact/compare/not_null__null",
-	                test_purple_contact_compare_not_null__null);
-	g_test_add_func("/contact/compare/null__not_null",
-	                test_purple_contact_compare_null__not_null);
-	g_test_add_func("/contact/compare/null__null",
-	                test_purple_contact_compare_null__null);
-	g_test_add_func("/contact/compare/person__no_person",
-	                test_purple_contact_compare_person__no_person);
-	g_test_add_func("/contact/compare/no_person__person",
-	                test_purple_contact_compare_no_person__person);
-	g_test_add_func("/contact/compare/name__name",
-	                test_purple_contact_compare_name__name);
+	g_test_add_func("/contact-info/compare/not_null__null",
+	                test_purple_contact_info_compare_not_null__null);
+	g_test_add_func("/contact-info/compare/null__not_null",
+	                test_purple_contact_info_compare_null__not_null);
+	g_test_add_func("/contact-info/compare/null__null",
+	                test_purple_contact_info_compare_null__null);
+	g_test_add_func("/contact-info/compare/person__no_person",
+	                test_purple_contact_info_compare_person__no_person);
+	g_test_add_func("/contact-info/compare/no_person__person",
+	                test_purple_contact_info_compare_no_person__person);
+	g_test_add_func("/contact-info/compare/name__name",
+	                test_purple_contact_info_compare_name__name);
 
 	return g_test_run();
 }
diff --git a/libpurple/tests/test_contact_manager.c b/libpurple/tests/test_contact_manager.c
--- a/libpurple/tests/test_contact_manager.c
+++ b/libpurple/tests/test_contact_manager.c
@@ -199,11 +199,11 @@
 	account = purple_account_new("test", "test");
 
 	contact1 = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact1, "user1");
+	purple_contact_info_set_username(PURPLE_CONTACT_INFO(contact1), "user1");
 	purple_contact_manager_add(manager, contact1);
 
 	contact2 = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact2, "user2");
+	purple_contact_info_set_username(PURPLE_CONTACT_INFO(contact2), "user2");
 	purple_contact_manager_add(manager, contact2);
 
 	found = purple_contact_manager_find_with_username(manager, account,
@@ -265,6 +265,7 @@
 	PurpleAccount *account = NULL;
 	PurpleBuddy *buddy = NULL;
 	PurpleContact *contact = NULL;
+	PurpleContactInfo *info = NULL;
 	PurpleContactManager *manager = NULL;
 	PurpleStatusType *type = NULL;
 	GList *statuses = NULL;
@@ -298,15 +299,17 @@
 	g_assert_nonnull(contact);
 	g_assert_true(PURPLE_IS_CONTACT(contact));
 
+	info = PURPLE_CONTACT_INFO(contact);
+
 	/* Now check the alias and display name to make sure they were synced as
 	 * well.
 	 */
 	source = purple_buddy_get_local_alias(buddy);
-	destination = purple_contact_get_alias(contact);
+	destination = purple_contact_info_get_alias(info);
 	g_assert_cmpstr(destination, ==, source);
 
 	source = purple_buddy_get_server_alias(buddy);
-	destination = purple_contact_get_display_name(contact);
+	destination = purple_contact_info_get_display_name(info);
 	g_assert_cmpstr(destination, ==, source);
 
 	/* Now let's change the settings in the buddy and verify they made it to the
@@ -319,16 +322,16 @@
 	*/
 
 	purple_buddy_set_local_alias(buddy, "guy-alias");
-	g_assert_cmpstr(purple_contact_get_alias(contact), ==, "guy-alias");
+	g_assert_cmpstr(purple_contact_info_get_alias(info), ==, "guy-alias");
 
 	purple_buddy_set_server_alias(buddy, "server-guy");
-	g_assert_cmpstr(purple_contact_get_display_name(contact), ==,
+	g_assert_cmpstr(purple_contact_info_get_display_name(info), ==,
 	                "server-guy");
 
-	purple_contact_set_alias(contact, "friend-alias");
+	purple_contact_info_set_alias(info, "friend-alias");
 	g_assert_cmpstr(purple_buddy_get_local_alias(buddy), ==, "friend-alias");
 
-	purple_contact_set_display_name(contact, "server-friend");
+	purple_contact_info_set_display_name(info, "server-friend");
 	g_assert_cmpstr(purple_buddy_get_server_alias(buddy), ==, "server-friend");
 
 	/* We can't verify the presences changes because PurpleBuddy has to be in
diff --git a/libpurple/tests/test_person.c b/libpurple/tests/test_person.c
--- a/libpurple/tests/test_person.c
+++ b/libpurple/tests/test_person.c
@@ -109,63 +109,58 @@
 
 static void
 test_purple_person_contacts_single(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
+	PurpleContactInfo *info = NULL;
 	PurplePerson *person = NULL;
 	PurplePerson *person1 = NULL;
 	guint n_items = 0;
 	gboolean removed = FALSE;
 	gboolean changed = FALSE;
 
-	account = purple_account_new("test", "test");
-	contact = purple_contact_new(account, "username");
+	info = purple_contact_info_new("id");
 	person = purple_person_new();
 	g_signal_connect(person, "items-changed",
 	                 G_CALLBACK(test_purple_person_items_changed_cb), &changed);
 
 	n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
 	g_assert_cmpuint(n_items, ==, 0);
-	purple_person_add_contact(person, contact);
+	purple_person_add_contact_info(person, info);
 	n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
 	g_assert_cmpuint(n_items, ==, 1);
 	g_assert_true(changed);
 
-	person1 = purple_contact_get_person(contact);
+	person1 = purple_contact_info_get_person(info);
 	g_assert_true(person1 == person);
 
 	changed = FALSE;
 
-	removed = purple_person_remove_contact(person, contact);
+	removed = purple_person_remove_contact_info(person, info);
 	g_assert_true(removed);
 	n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
 	g_assert_cmpuint(n_items, ==, 0);
 	g_assert_true(changed);
 
-	person1 = purple_contact_get_person(contact);
+	person1 = purple_contact_info_get_person(info);
 	g_assert_null(person1);
 
 	g_clear_object(&person);
-	g_clear_object(&account);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 }
 
 static void
 test_purple_person_contacts_multiple(void) {
-	PurpleAccount *account = NULL;
 	PurplePerson *person = NULL;
-	GPtrArray *contacts = NULL;
+	GPtrArray *infos = NULL;
 	guint n_items = 0;
-	const gint n_contacts = 5;
+	const gint n_infos = 5;
 	gboolean changed = FALSE;
 
-	account = purple_account_new("test", "test");
 	person = purple_person_new();
 	g_signal_connect(person, "items-changed",
 	                 G_CALLBACK(test_purple_person_items_changed_cb), &changed);
 
-	contacts = g_ptr_array_new_full(n_contacts, g_object_unref);
-	for(gint i = 0; i < n_contacts; i++) {
-		PurpleContact *contact = NULL;
+	infos = g_ptr_array_new_full(n_infos, g_object_unref);
+	for(gint i = 0; i < n_infos; i++) {
+		PurpleContactInfo *info = NULL;
 		gchar *username = NULL;
 
 		changed = FALSE;
@@ -174,35 +169,36 @@
 		g_assert_cmpuint(n_items, ==, i);
 
 		username = g_strdup_printf("username%d", i);
-		contact = purple_contact_new(account, username);
+		info = purple_contact_info_new(NULL);
+		purple_contact_info_set_username(info, username);
 		g_free(username);
 
-		/* Add the contact to the ptr array so we can remove it below. */
-		g_ptr_array_add(contacts, contact);
+		/* Add the contact info to the ptr array so we can remove it below. */
+		g_ptr_array_add(infos, info);
 
-		/* Add the contact to the person and make sure that all the magic
+		/* Add the contact info to the person and make sure that all the magic
 		 * happened.
 		 */
-		purple_person_add_contact(person, contact);
+		purple_person_add_contact_info(person, info);
 		n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
 		g_assert_cmpuint(n_items, ==, i + 1);
 		g_assert_true(changed);
 	}
 
-	for(gint i = 0; i < n_contacts; i++) {
-		PurpleContact *contact = contacts->pdata[i];
+	for(gint i = 0; i < n_infos; i++) {
+		PurpleContactInfo *info = g_ptr_array_index(infos, i);
 		gboolean removed = FALSE;
 
 		changed = FALSE;
 
 		n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
-		g_assert_cmpuint(n_items, ==, n_contacts - i);
+		g_assert_cmpuint(n_items, ==, n_infos - i);
 
-		removed = purple_person_remove_contact(person, contact);
+		removed = purple_person_remove_contact_info(person, info);
 		g_assert_true(removed);
 
 		n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
-		g_assert_cmpuint(n_items, ==, n_contacts - (i + 1));
+		g_assert_cmpuint(n_items, ==, n_infos - (i + 1));
 
 		g_assert_true(changed);
 	}
@@ -211,37 +207,33 @@
 	n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
 	g_assert_cmpuint(n_items, ==, 0);
 
-	g_ptr_array_free(contacts, TRUE);
+	g_ptr_array_free(infos, TRUE);
 
 	g_clear_object(&person);
-	g_clear_object(&account);
 }
 
 static void
 test_purple_person_priority_single(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-	PurpleContact *priority = NULL;
+	PurpleContactInfo *info = NULL;
+	PurpleContactInfo *priority = NULL;
 	PurplePerson *person = NULL;
 	PurplePresence *presence = NULL;
 	PurpleStatus *status = NULL;
 	PurpleStatusType *status_type = NULL;
 	gboolean called = FALSE;
 
-	account = purple_account_new("test", "test");
-
 	person = purple_person_new();
 	g_signal_connect(person, "notify::priority-contact",
 	                 G_CALLBACK(test_purple_person_notify_cb), &called);
-	priority = purple_person_get_priority_contact(person);
+	priority = purple_person_get_priority_contact_info(person);
 	g_assert_null(priority);
 
 	/* Now create a real contact. */
-	contact = purple_contact_new(account, "username");
-	purple_person_add_contact(person, contact);
+	info = purple_contact_info_new(NULL);
+	purple_person_add_contact_info(person, info);
 
 	/* Set the status of the contact. */
-	presence = purple_contact_get_presence(contact);
+	presence = purple_contact_info_get_presence(info);
 	status_type = purple_status_type_new(PURPLE_STATUS_AVAILABLE, "available",
 	                                     "Available", FALSE);
 	status = purple_status_new(status_type, presence);
@@ -250,40 +242,37 @@
 
 	g_assert_true(called);
 
-	priority = purple_person_get_priority_contact(person);
-	g_assert_true(priority == contact);
+	priority = purple_person_get_priority_contact_info(person);
+	g_assert_true(priority == info);
 
 	purple_status_type_destroy(status_type);
-	g_clear_object(&account);
 	g_clear_object(&person);
-	g_clear_object(&contact);
+	g_clear_object(&info);
 	g_clear_object(&presence);
 }
 
 static void
 test_purple_person_priority_multiple_with_change(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *priority = NULL;
-	PurpleContact *first = NULL;
-	PurpleContact *sorted_contact = NULL;
+	PurpleContactInfo *priority = NULL;
+	PurpleContactInfo *first = NULL;
+	PurpleContactInfo *sorted_contact = NULL;
 	PurplePerson *person = NULL;
 	PurplePresence *sorted_presence = NULL;
 	PurpleStatus *status = NULL;
 	PurpleStatusType *available = NULL;
 	PurpleStatusType *offline = NULL;
 	gboolean changed = FALSE;
-	gint n_contacts = 5;
+	gint n_infos = 5;
 	guint n_items = 0;
 
-	/* This unit test is a bit complicated, but it adds 5 contacts to a person
-	 * all whose presences are set to offline. After adding all the contacts,
-	 * we verify that the first contact we added is the priority contact. Then
-	 * we flip the active status of the n_contacts - 2 contact to available.
-	 * This should make it the priority contact which we then assert.
+	/* This unit test is a bit complicated, but it adds 5 contact infos to a
+	 * person all whose presences are set to offline. After adding all the
+	 * contact infos, we verify that the first contact info we added is the
+	 * priority contact info. Then we flip the active status of the n_infos - 2
+	 * infos to available. This should make it the priority contact info which
+	 * we then assert.
 	 */
 
-	account = purple_account_new("test", "test");
-
 	/* Create our status types. */
 	available = purple_status_type_new(PURPLE_STATUS_AVAILABLE, "available",
 	                                   "Available", FALSE);
@@ -296,12 +285,12 @@
 	person = purple_person_new();
 	g_signal_connect(person, "notify::priority-contact",
 	                 G_CALLBACK(test_purple_person_notify_cb), &changed);
-	priority = purple_person_get_priority_contact(person);
+	priority = purple_person_get_priority_contact_info(person);
 	g_assert_null(priority);
 
-	/* Create and add all contacts. */
-	for(gint i = 0; i < n_contacts; i++) {
-		PurpleContact *contact = NULL;
+	/* Create and add all contact infos. */
+	for(gint i = 0; i < n_infos; i++) {
+		PurpleContactInfo *info = NULL;
 		PurplePresence *presence = NULL;
 		gchar *username = NULL;
 
@@ -310,48 +299,49 @@
 
 		/* Now create a real contact. */
 		username = g_strdup_printf("username%d", i + 1);
-		contact = purple_contact_new(account, username);
+		info = purple_contact_info_new(NULL);
+		purple_contact_info_set_username(info, username);
 		g_free(username);
 
 		/* Set the status for the contact. */
-		presence = purple_contact_get_presence(contact);
+		presence = purple_contact_info_get_presence(info);
 		status = purple_status_new(offline, presence);
 		g_object_set(G_OBJECT(presence), "active-status", status, NULL);
 		g_clear_object(&status);
 
-		purple_person_add_contact(person, contact);
+		purple_person_add_contact_info(person, info);
 
 		if(i == 0) {
-			first = g_object_ref(contact);
+			first = g_object_ref(info);
 			g_assert_true(changed);
 		} else {
 			g_assert_false(changed);
 
-			if(i == n_contacts - 2) {
-				sorted_contact = g_object_ref(contact);
+			if(i == n_infos - 2) {
+				sorted_contact = g_object_ref(info);
 				sorted_presence = g_object_ref(presence);
 			}
 		}
 
-		g_clear_object(&contact);
+		g_clear_object(&info);
 	}
 
 	n_items = g_list_model_get_n_items(G_LIST_MODEL(person));
-	g_assert_cmpuint(n_items, ==, n_contacts);
+	g_assert_cmpuint(n_items, ==, n_infos);
 
-	priority = purple_person_get_priority_contact(person);
+	priority = purple_person_get_priority_contact_info(person);
 	g_assert_true(priority == first);
 	g_clear_object(&first);
 
-	/* Now set the second from the last contact's status to available, and
-	 * verify that that contact is now the priority contact.
+	/* Now set the second from the last contact info's status to available, and
+	 * verify that that contact info is now the priority contact info.
 	 */
 	changed = FALSE;
 	status = purple_status_new(available, sorted_presence);
 	g_object_set(G_OBJECT(sorted_presence), "active-status", status, NULL);
 	g_clear_object(&status);
 	g_assert_true(changed);
-	priority = purple_person_get_priority_contact(person);
+	priority = purple_person_get_priority_contact_info(person);
 	g_assert_true(priority == sorted_contact);
 
 	/* Cleanup. */
@@ -361,7 +351,6 @@
 	g_clear_object(&sorted_contact);
 	g_clear_object(&sorted_presence);
 
-	g_clear_object(&account);
 	g_clear_object(&person);
 }
 
